'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// import R from 'ramda';

var Yosgo = function () {
  function Yosgo(baseApiURL, apiKey) {
    _classCallCheck(this, Yosgo);

    this.baseApiURL = baseApiURL, this.apiKey = apiKey, this.createRequest = this.createRequest.bind(this);
  }

  _createClass(Yosgo, [{
    key: 'createRequest',
    value: function createRequest() {
      var axiosInit = _axios2.default.create({
        baseURL: this.baseApiURL,
        timeout: 20000,
        headers: {
          'content-type': 'application/json',
          'yosgo-api-key': this.apiKey
        }
      });
      return axiosInit;
    }
  }, {
    key: 'brandFetch',
    value: function brandFetch() {
      var _this = this;

      return new Promise(function (resolve, reject) {
        _this.createRequest().get('/brands').then(function (respones) {
          console.log('[Console] Fetch brands success -> ', respones.data);
          resolve(respones.data);
        });
      });
    }
  }, {
    key: 'productsFetch',
    value: function productsFetch() {
      var _this2 = this;

      return new Promise(function (resolve, reject) {
        _this2.createRequest().get('/products').then(function (response) {
          console.log('[Console] Fetch products success');
          resolve(response.data.payload);
        });
      });
    }
  }, {
    key: 'productFetch',
    value: function productFetch(productId) {
      var _this3 = this;

      return new Promise(function (resolve, reject) {
        _this3.createRequest().get('/products/' + productId).then(function (response) {
          console.log('[Console] Fetch certain product success');
          resolve(response.data.payload);
        });
      });
    }
  }, {
    key: 'groupCreate',
    value: function groupCreate(productId, note) {
      var _this4 = this;

      return new Promise(function (resolve, reject) {
        _this4.createRequest().post('/groups', {
          productId: productId,
          note: note
        }).then(function (responses) {
          console.log('[Console] Create Group Success');
          resolve(responses);
        });
      });
    }
  }, {
    key: 'groupsFetch',
    value: function groupsFetch() {
      var _this5 = this;

      return new Promise(function (resolve, reject) {
        _this5.createRequest().get('/groups').then(function (response) {
          console.log('[Console] Fetch groups success');
          resolve(response.data.payload);
        });
      });
    }
  }, {
    key: 'orderCreate',
    value: function orderCreate(productId, groupId, data, extraRegistrations, quantity) {
      var _this6 = this;

      return new Promise(function (resolve, reject) {
        _this6.createRequest().post('/orders', {
          registration: {
            name: data.name,
            phone: data.phone,
            email: data.email,
            notes: data.notes,
            address: data.address
          },
          extraRegistrations: extraRegistrations,
          order: {
            quantity: quantity,
            productId: productId,
            groupId: groupId
          }
        }).then(function (response) {
          console.log('[Console] Create order success');
          resolve(response.data.payload.objectId);
        });
      });
      // Validate
      // 1. Five params should be exist if not return required hint
      // 2. Quantity should be number if not return format hint
      // 3. Make sure product is not expired
      // 4. Make sure group's quantity is enough or not
    }
  }, {
    key: 'ordersFetch',
    value: function ordersFetch() {
      var _this7 = this;

      return new Promise(function (resolve, reject) {
        _this7.createRequest().get('/orders').then(function (response) {
          console.log('[Console] Fetch orders success');
          resolve(response.data.payload);
        });
      });
    }
  }, {
    key: 'paymentCreate',
    value: function paymentCreate(orderId, next) {
      var _this8 = this;

      return new Promise(function (resolve, reject) {
        _this8.createRequest().post('/orders/payment', {
          orderId: orderId,
          next: next
        }).then(function (response) {
          console.log('[Console] Create payment success');
          resolve(response.data.payload.order.payment.data.html);
        });
      });
    }
  }]);

  return Yosgo;
}();

exports.default = Yosgo;